diff --git a/sys/contrib/dev/acpica/source/common/dmtbdump2.c b/sys/contrib/dev/acpica/source/common/dmtbdump2.c
index 04f7139fe9..f9145d7cb5 100644
--- a/sys/contrib/dev/acpica/source/common/dmtbdump2.c
+++ b/sys/contrib/dev/acpica/source/common/dmtbdump2.c
@@ -1469,515 +1766,106 @@ AcpiDmDumpNfit (
 
 /*******************************************************************************
  *
- * FUNCTION:    AcpiDmDumpNhlt
+ * FUNCTION:    AcpiDmDumpPcct
  *
- * PARAMETERS:  Table               - A NHLT table
+ * PARAMETERS:  Table               - A PCCT table
  *
  * RETURN:      None
  *
- * DESCRIPTION: Format the contents of an NHLT.
+ * DESCRIPTION: Format the contents of a PCCT. This table type consists
+ *              of an open-ended number of subtables.
  *
  ******************************************************************************/
 
 void
-AcpiDmDumpNhlt (
+AcpiDmDumpPcct (
     ACPI_TABLE_HEADER       *Table)
 {
     ACPI_STATUS             Status;
-    UINT32                  Offset;
-    UINT32                  TableLength = Table->Length;
-    UINT32                  EndpointCount;
-    UINT8                   FormatsCount;
-    ACPI_NHLT_ENDPOINT      *Subtable;
-    ACPI_NHLT_FORMAT_CONFIG *FormatSubtable;
-    ACPI_TABLE_NHLT         *InfoTable;
-    UINT32                  CapabilitiesSize;
-    UINT32                  i;
-    UINT32                  j;
-    UINT32                  EndpointEndOffset;
-    UINT8                   ConfigType = 0;
-    UINT8                   ArrayType;
-    UINT8                   MicrophoneCount;
-    ACPI_NHLT_VENDOR_MIC_COUNT          *MicCount;
-    ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A  *DevSpecific;
-    ACPI_NHLT_FORMATS_CONFIG            *FormatsConfig;
-    ACPI_NHLT_LINUX_SPECIFIC_COUNT      *Count;
-    ACPI_NHLT_LINUX_SPECIFIC_DATA       *LinuxData;
-    ACPI_NHLT_LINUX_SPECIFIC_DATA_B     *LinuxDataB;
+    ACPI_PCCT_SUBSPACE      *Subtable;
+    ACPI_DMTABLE_INFO       *InfoTable;
+    UINT32                  Length = Table->Length;
+    UINT32                  Offset = sizeof (ACPI_TABLE_PCCT);
 
 
     /* Main table */
 
-    AcpiOsPrintf ("    /* Main table */\n");
-
-    Status = AcpiDmDumpTable (TableLength, 0, Table, 0, AcpiDmTableInfoNhlt);
+    Status = AcpiDmDumpTable (Length, 0, Table, 0, AcpiDmTableInfoPcct);
     if (ACPI_FAILURE (Status))
     {
         return;
     }
 
-    /* Get the Endpoint Descriptor Count */
-
-    InfoTable = ACPI_ADD_PTR (ACPI_TABLE_NHLT, Table, 0);
-    EndpointCount = InfoTable->EndpointCount;
-
     /* Subtables */
 
-    Offset = sizeof (ACPI_TABLE_NHLT);
-
-    while (Offset < TableLength)
+    Subtable = ACPI_ADD_PTR (ACPI_PCCT_SUBSPACE, Table, Offset);
+    while (Offset < Table->Length)
     {
-        /* A variable number of Endpoint Descriptors - process each */
+        /* Common subtable header */
 
-        for (i = 0; i < EndpointCount; i++)
+        AcpiOsPrintf ("\n");
+        Status = AcpiDmDumpTable (Length, Offset, Subtable,
+            Subtable->Header.Length, AcpiDmTableInfoPcctHdr);
+        if (ACPI_FAILURE (Status))
         {
-            /* Do the Endpoint Descriptor table */
-
-            Subtable = ACPI_ADD_PTR (ACPI_NHLT_ENDPOINT, Table, Offset);
-
-            /* Check for endpoint descriptor length beyond end-of-table */
-
-            if (Subtable->DescriptorLength > TableLength)
-            {
-                Offset += 1;
-                AcpiOsPrintf ("\n    /* Endpoint Descriptor Length larger than"
-                    " table size: %X, table %X, adjusting table offset (+1) */\n",
-                    Subtable->DescriptorLength, TableLength);
+            return;
+        }
 
-                Subtable = ACPI_ADD_PTR (ACPI_NHLT_ENDPOINT, Table, Offset);
-            }
+        switch (Subtable->Header.Type)
+        {
+        case ACPI_PCCT_TYPE_GENERIC_SUBSPACE:
 
-            AcpiOsPrintf ("\n    /* Endpoint Descriptor #%u */\n", i+1);
-            Status = AcpiDmDumpTable (TableLength, Offset, Subtable,
-                Subtable->DescriptorLength, AcpiDmTableInfoNhlt0);
-            if (ACPI_FAILURE (Status))
-            {
-                return;
-            }
+            InfoTable = AcpiDmTableInfoPcct0;
+            break;
 
-            EndpointEndOffset = Subtable->DescriptorLength + Offset;
+        case ACPI_PCCT_TYPE_HW_REDUCED_SUBSPACE:
 
-            /* Check for endpoint descriptor beyond end-of-table */
+            InfoTable = AcpiDmTableInfoPcct1;
+            break;
 
-            if (Subtable->DescriptorLength > TableLength)
-            {
-                AcpiOsPrintf ("\n    /* Endpoint Descriptor Length larger than table size: %X, table %X */\n",
-                    Subtable->DescriptorLength, TableLength);
-            }
+        case ACPI_PCCT_TYPE_HW_REDUCED_SUBSPACE_TYPE2:
 
-            Offset += sizeof (ACPI_NHLT_ENDPOINT);
-            Subtable = ACPI_ADD_PTR (ACPI_NHLT_ENDPOINT, Table, Offset);
+            InfoTable = AcpiDmTableInfoPcct2;
+            break;
 
-            /* Do the Device Specific table */
+        case ACPI_PCCT_TYPE_EXT_PCC_MASTER_SUBSPACE:
 
-            AcpiOsPrintf ("\n    /* Endpoint Device_Specific_Config table */\n");
-            DevSpecific = ACPI_CAST_PTR (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A, Subtable);
-            CapabilitiesSize = DevSpecific->CapabilitiesSize;
-            Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_B), AcpiDmTableInfoNhlt5b);
-            if (ACPI_FAILURE (Status))
-            {
-                return;
-            }
+            InfoTable = AcpiDmTableInfoPcct3;
+            break;
 
-            ArrayType = 0;
+        case ACPI_PCCT_TYPE_EXT_PCC_SLAVE_SUBSPACE:
 
-            /* Different subtables based upon capabilities_size */
+            InfoTable = AcpiDmTableInfoPcct4;
+            break;
 
-            switch (CapabilitiesSize)
-            {
-            case 0:
-                Offset += sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_B);
-                break;
+        case ACPI_PCCT_TYPE_HW_REG_COMM_SUBSPACE:
 
-            case 1:
-                Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                    sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_C), AcpiDmTableInfoNhlt5c);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
-                Offset += sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_C);
-                break;
+            InfoTable = AcpiDmTableInfoPcct5;
+            break;
 
-            case 2:
-                Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                    sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG), AcpiDmTableInfoNhlt5);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
-                Offset += sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG);
-                break;
+        default:
 
-            case 3:
-            default:
-                /* Extract the ConfigType and ArrayType */
+            AcpiOsPrintf (
+                "\n**** Unexpected or unknown PCCT subtable type 0x%X\n\n",
+                Subtable->Header.Type);
+            return;
+        }
 
-                ConfigType = DevSpecific->ConfigType;
-                ArrayType = DevSpecific->ArrayType;
+        AcpiOsPrintf ("\n");
+        Status = AcpiDmDumpTable (Length, Offset, Subtable,
+            Subtable->Header.Length, InfoTable);
+        if (ACPI_FAILURE (Status))
+        {
+            return;
+        }
 
-                Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                    sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A), AcpiDmTableInfoNhlt5a);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
+        /* Point to next subtable */
 
-                /* Capabilities Size == 3 */
-                Offset += sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A);
-                break;
-
-            case 7:
-                ConfigType = DevSpecific->ConfigType;
-                Subtable = ACPI_ADD_PTR (ACPI_NHLT_ENDPOINT, Table, Offset);
-                DevSpecific = ACPI_CAST_PTR (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A, Subtable);
-
-                AcpiOsPrintf ("\n    /* Render Feedback Device-Specific table */\n");
-                Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                    sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG), AcpiDmTableInfoNhlt5);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
-
-                /* Capabilities Size = 7 */
-                Offset += sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG);
-
-                if (ConfigType == ACPI_NHLT_CONFIG_TYPE_RENDER_FEEDBACK)
-                {
-                    Subtable = ACPI_ADD_PTR (ACPI_NHLT_ENDPOINT, Table, Offset);
-                    DevSpecific = ACPI_CAST_PTR (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A, Subtable);
-
-                    Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                        sizeof (ACPI_NHLT_RENDER_FEEDBACK_DEVICE_SPECIFIC_CONFIG), AcpiDmTableInfoNhlt6b);
-                    if (ACPI_FAILURE (Status))
-                    {
-                        return;
-                    }
-                    Offset += sizeof (ACPI_NHLT_RENDER_FEEDBACK_DEVICE_SPECIFIC_CONFIG);
-                }
-                break;
-           }
-
-            /* Check for a vendor-defined mic array */
-
-            if (ConfigType == ACPI_NHLT_CONFIG_TYPE_MIC_ARRAY)
-            {
-                if ((ArrayType & ACPI_NHLT_ARRAY_TYPE_MASK) == ACPI_NHLT_VENDOR_DEFINED)
-                {
-                    /* Vendor-defined microphone array; get the microphone count first */
-
-                    AcpiOsPrintf ("\n    /* Vendor-defined microphone count */\n");
-                    MicCount = ACPI_ADD_PTR (ACPI_NHLT_VENDOR_MIC_COUNT, Table, Offset);
-                    MicrophoneCount = MicCount->MicrophoneCount;
-
-                    Status = AcpiDmDumpTable (TableLength, Offset, MicCount,
-                        sizeof (ACPI_NHLT_VENDOR_MIC_COUNT), AcpiDmTableInfoNhlt6a);
-                    Offset += sizeof (ACPI_NHLT_VENDOR_MIC_COUNT);
-                    if (ACPI_FAILURE (Status))
-                    {
-                        return;
-                    }
-
-                    /* Get the vendor microphone config structure(s) */
-
-                    for (j = 0; j < MicrophoneCount; j++)
-                    {
-                        AcpiOsPrintf ("\n    /* Vendor-defined microphone array #%u*/\n", j+1);
-                        DevSpecific = ACPI_ADD_PTR (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A, Table, Offset);
-
-                        Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                            sizeof (ACPI_NHLT_VENDOR_MIC_CONFIG), AcpiDmTableInfoNhlt6);
-                        if (ACPI_FAILURE (Status))
-                        {
-                            return;
-                        }
-
-                        Offset += sizeof (ACPI_NHLT_VENDOR_MIC_CONFIG);
-                    }
-
-                    /* Check for Microphone SNR and sensitivity extension */
-
-                    if ((ArrayType & ACPI_NHLT_ARRAY_TYPE_EXT_MASK) == ACPI_NHLT_MIC_SNR_SENSITIVITY_EXT)
-                    {
-                        AcpiOsPrintf ("\n    /* Microphone SNR and sensitivity array */\n");
-                        DevSpecific = ACPI_ADD_PTR (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A, Table, Offset);
-
-                        Status = AcpiDmDumpTable (TableLength, Offset, DevSpecific,
-                            sizeof (ACPI_NHLT_MIC_SNR_SENSITIVITY_EXTENSION), AcpiDmTableInfoNhlt9);
-                        if (ACPI_FAILURE (Status))
-                        {
-                            return;
-                        }
-
-                        Offset += sizeof (ACPI_NHLT_MIC_SNR_SENSITIVITY_EXTENSION);
-                    }
-                }
-            }
-
-            /* Do the Formats_Config table - starts with the FormatsCount field */
-
-            FormatsConfig = ACPI_ADD_PTR (ACPI_NHLT_FORMATS_CONFIG, Table, Offset);
-            FormatsCount = FormatsConfig->FormatsCount;
-
-            AcpiOsPrintf ("\n    /* Formats_Config table */\n");
-
-            /* Dump the FormatsCount value */
-
-            if (FormatsCount > 0)
-            {
-                Status = AcpiDmDumpTable (TableLength, Offset, FormatsConfig,
-                    sizeof (ACPI_NHLT_FORMATS_CONFIG), AcpiDmTableInfoNhlt4);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
-            }
-            Offset += sizeof (ACPI_NHLT_FORMATS_CONFIG);
-
-            /* A variable number of Format_Config Descriptors - process each */
-
-            for (j = 0; j < FormatsCount; j++)
-            {
-                FormatSubtable = ACPI_ADD_PTR (ACPI_NHLT_FORMAT_CONFIG, Table, Offset);
-                CapabilitiesSize = FormatSubtable->CapabilitySize;
-
-                /* Do the Wave_extensible struct */
-
-                AcpiOsPrintf ("\n    /* Wave_Format_Extensible table #%u */\n", j+1);
-                Status = AcpiDmDumpTable (TableLength, Offset, FormatSubtable,
-                    sizeof (ACPI_NHLT_FORMAT_CONFIG), AcpiDmTableInfoNhlt3);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
-
-                Offset += sizeof (ACPI_NHLT_FORMAT_CONFIG);
-
-                if (CapabilitiesSize > 0)
-                {
-                    FormatSubtable = ACPI_ADD_PTR (ACPI_NHLT_FORMAT_CONFIG, Table, Offset);
-                    /* Do the Capabilities array (of bytes) */
-
-                    AcpiOsPrintf ("\n    /* Specific_Config table #%u */\n", j+1);
-                    FormatSubtable = ACPI_ADD_PTR (ACPI_NHLT_FORMAT_CONFIG, Table, Offset);
-                    Status = AcpiDmDumpTable (TableLength, Offset, FormatSubtable,
-                        CapabilitiesSize, AcpiDmTableInfoNhlt3a);
-                    if (ACPI_FAILURE (Status))
-                    {
-                        return;
-                    }
-
-                    Offset += CapabilitiesSize; // + sizeof (ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_B);
-                }
-
-            } /* for (j = 0; j < FormatsCount; j++) */
-
-            /*
-             * If we are not done with the current Endpoint yet, then there must be
-             * some Linux-specific structure(s) yet to be processed. First, get
-             * the count of such structure(s).
-             */
-            if (Offset < EndpointEndOffset)
-            {
-                AcpiOsPrintf ("\n    /* Linux-specific structures (not part of NHLT spec) */\n");
-                Count = ACPI_ADD_PTR (ACPI_NHLT_LINUX_SPECIFIC_COUNT, Table, Offset);
-                Status = AcpiDmDumpTable (TableLength, Offset, Count,
-                    sizeof (ACPI_NHLT_LINUX_SPECIFIC_COUNT), AcpiDmTableInfoNhlt7);
-                if (ACPI_FAILURE (Status))
-                {
-                    return;
-                }
-                Offset += sizeof (ACPI_NHLT_LINUX_SPECIFIC_COUNT);
-
-                if (Count->StructureCount > 1)
-                {
-                    /*
-                     * We currently cannot disassemble more than one
-                     * Linux-Specific section, because we have no way of
-                     * knowing whether the "Specific Data" part is present.
-                     */
-                    Count->StructureCount = 1;
-                    fprintf (stderr, "%s %s\n", "Feature not supported:",
-                        "Cannot disassemble more than one Linux-Specific structure");
-                    return;
-                }
-
-                /* Variable number of linux-specific structures */
-
-                for (j = 0; j < Count->StructureCount; j++)
-                {
-                    LinuxData = ACPI_ADD_PTR (ACPI_NHLT_LINUX_SPECIFIC_DATA, Table, Offset);
-                    AcpiOsPrintf ("\n    /* Linux-specific structure #%u (not part of NHLT spec) */\n", j+1);
-
-                    /*
-                     * Dump the following Linux-specific fields:
-                     *  1) Device ID
-                     *  2) Device Instance ID
-                     *  3) Device Port ID
-                     */
-                    Status = AcpiDmDumpTable (TableLength, Offset, LinuxData,
-                        sizeof (ACPI_NHLT_LINUX_SPECIFIC_DATA), AcpiDmTableInfoNhlt7a);
-                    if (ACPI_FAILURE (Status))
-                    {
-                        return;
-                    }
-
-                    Offset += sizeof (ACPI_NHLT_LINUX_SPECIFIC_DATA);
-
-                    /*
-                     * Check that the current offset is not beyond the end of
-                     * this endpoint descriptor. If it is not, we assume that
-                     * the "Specific Data" field is present and valid. Note:
-                     * This does not seem to be documented anywhere.
-                     */
-                    if (Offset < EndpointEndOffset)
-                    {
-                        /* Dump the linux-specific "Specific Data" field */
-
-                        LinuxDataB = ACPI_ADD_PTR (ACPI_NHLT_LINUX_SPECIFIC_DATA_B, Table, Offset);
-                        Status = AcpiDmDumpTable (TableLength, Offset, LinuxDataB,
-                            sizeof (ACPI_NHLT_LINUX_SPECIFIC_DATA_B), AcpiDmTableInfoNhlt7b);
-                        if (ACPI_FAILURE (Status))
-                        {
-                            return;
-                        }
-
-                        Offset += sizeof (ACPI_NHLT_LINUX_SPECIFIC_DATA_B);
-                    }
-                }
-
-                /* Should be at the end of the Endpoint structure. */
-            }
-
-        } /* for (i = 0; i < EndpointCount; i++) */
-
-
-        /*
-         * Done with all of the Endpoint Descriptors, Emit the table terminator
-         * (if such a legacy structure is present -- not in NHLT specification)
-         */
-        if (Offset == TableLength - sizeof (ACPI_NHLT_TABLE_TERMINATOR))
-        {
-            LinuxData = ACPI_ADD_PTR (ACPI_NHLT_LINUX_SPECIFIC_DATA, Table, Offset);
-            AcpiOsPrintf ("\n    /* Table terminator structure (not part of NHLT spec) */\n");
-
-            Status = AcpiDmDumpTable (TableLength, Offset, LinuxData,
-                sizeof (ACPI_NHLT_TABLE_TERMINATOR), AcpiDmTableInfoNhlt8);
-            if (ACPI_FAILURE (Status))
-            {
-                return;
-            }
-        }
-
-        return;
-    }
-}
-
-
-/*******************************************************************************
- *
- * FUNCTION:    AcpiDmDumpPcct
- *
- * PARAMETERS:  Table               - A PCCT table
- *
- * RETURN:      None
- *
- * DESCRIPTION: Format the contents of a PCCT. This table type consists
- *              of an open-ended number of subtables.
- *
- ******************************************************************************/
-
-void
-AcpiDmDumpPcct (
-    ACPI_TABLE_HEADER       *Table)
-{
-    ACPI_STATUS             Status;
-    ACPI_PCCT_SUBSPACE      *Subtable;
-    ACPI_DMTABLE_INFO       *InfoTable;
-    UINT32                  Length = Table->Length;
-    UINT32                  Offset = sizeof (ACPI_TABLE_PCCT);
-
-
-    /* Main table */
-
-    Status = AcpiDmDumpTable (Length, 0, Table, 0, AcpiDmTableInfoPcct);
-    if (ACPI_FAILURE (Status))
-    {
-        return;
-    }
-
-    /* Subtables */
-
-    Subtable = ACPI_ADD_PTR (ACPI_PCCT_SUBSPACE, Table, Offset);
-    while (Offset < Table->Length)
-    {
-        /* Common subtable header */
-
-        AcpiOsPrintf ("\n");
-        Status = AcpiDmDumpTable (Length, Offset, Subtable,
-            Subtable->Header.Length, AcpiDmTableInfoPcctHdr);
-        if (ACPI_FAILURE (Status))
-        {
-            return;
-        }
-
-        switch (Subtable->Header.Type)
-        {
-        case ACPI_PCCT_TYPE_GENERIC_SUBSPACE:
-
-            InfoTable = AcpiDmTableInfoPcct0;
-            break;
-
-        case ACPI_PCCT_TYPE_HW_REDUCED_SUBSPACE:
-
-            InfoTable = AcpiDmTableInfoPcct1;
-            break;
-
-        case ACPI_PCCT_TYPE_HW_REDUCED_SUBSPACE_TYPE2:
-
-            InfoTable = AcpiDmTableInfoPcct2;
-            break;
-
-        case ACPI_PCCT_TYPE_EXT_PCC_MASTER_SUBSPACE:
-
-            InfoTable = AcpiDmTableInfoPcct3;
-            break;
-
-        case ACPI_PCCT_TYPE_EXT_PCC_SLAVE_SUBSPACE:
-
-            InfoTable = AcpiDmTableInfoPcct4;
-            break;
-
-        case ACPI_PCCT_TYPE_HW_REG_COMM_SUBSPACE:
-
-            InfoTable = AcpiDmTableInfoPcct5;
-            break;
-
-        default:
-
-            AcpiOsPrintf (
-                "\n**** Unexpected or unknown PCCT subtable type 0x%X\n\n",
-                Subtable->Header.Type);
-            return;
-        }
-
-        AcpiOsPrintf ("\n");
-        Status = AcpiDmDumpTable (Length, Offset, Subtable,
-            Subtable->Header.Length, InfoTable);
-        if (ACPI_FAILURE (Status))
-        {
-            return;
-        }
-
-        /* Point to next subtable */
-
-        Offset += Subtable->Header.Length;
-        Subtable = ACPI_ADD_PTR (ACPI_PCCT_SUBSPACE, Subtable,
-            Subtable->Header.Length);
-    }
-}
+        Offset += Subtable->Header.Length;
+        Subtable = ACPI_ADD_PTR (ACPI_PCCT_SUBSPACE, Subtable,
+            Subtable->Header.Length);
+    }
+}
 
 
 /*******************************************************************************
@@ -2054,12 +1942,15 @@ AcpiDmDumpPhat (
     ACPI_DMTABLE_INFO       *InfoTable;
     ACPI_PHAT_HEADER        *Subtable;
     ACPI_PHAT_VERSION_DATA  *VersionData;
+    ACPI_PHAT_HEALTH_DATA   *HealthData;
     UINT32                  RecordCount;
     UINT32                  Length = Table->Length;
     UINT32                  Offset = sizeof (ACPI_TABLE_PHAT);
+    UINT32                  OriginalOffset;
     UINT32                  SubtableLength;
     UINT32                  PathLength;
     UINT32                  VendorLength;
+    UINT16                  RecordType;
 
 
     Subtable = ACPI_ADD_PTR (ACPI_PHAT_HEADER, Table, sizeof (ACPI_TABLE_PHAT));
@@ -2069,13 +1960,16 @@ AcpiDmDumpPhat (
         /* Common subtable header */
 
         AcpiOsPrintf ("\n");
-        Status = AcpiDmDumpTable (Length, 0, Subtable,
+        Status = AcpiDmDumpTable (Length, Offset, Subtable,
             sizeof (ACPI_PHAT_HEADER), AcpiDmTableInfoPhatHdr);
         if (ACPI_FAILURE (Status))
         {
             return;
         }
 
+        DbgPrint (ASL_DEBUG_OUTPUT, "\n/* %u, Subtable->Type %X */\n",
+            __LINE__, Subtable->Type);
+
         switch (Subtable->Type)
         {
         case ACPI_PHAT_TYPE_FW_VERSION_DATA:
@@ -2092,35 +1986,69 @@ AcpiDmDumpPhat (
 
         default:
 
-            AcpiOsPrintf ("\n**** Unknown PHAT subtable type 0x%X\n\n",
+            DbgPrint (ASL_DEBUG_OUTPUT, "\n**** Unknown PHAT subtable type 0x%X\n\n",
                 Subtable->Type);
 
             return;
         }
 
-        Status = AcpiDmDumpTable (Length, 0, Subtable,
+        Status = AcpiDmDumpTable (Length, Offset, Subtable,
             SubtableLength, InfoTable);
         if (ACPI_FAILURE (Status))
         {
             return;
         }
 
+        Offset += SubtableLength;
+
+        OriginalOffset = Offset;
         switch (Subtable->Type)
         {
         case ACPI_PHAT_TYPE_FW_VERSION_DATA:
 
             VersionData = ACPI_CAST_PTR (ACPI_PHAT_VERSION_DATA, Subtable);
             RecordCount = VersionData->ElementCount;
-            while (RecordCount)
+            RecordType = *ACPI_CAST_PTR (UINT8, Subtable);
+
+            /*
+             * Skip past a zero-valued block (not part of the ACPI PHAT specification).
+             * First, check for a zero length record and a zero element count
+             */
+            if (!VersionData->Header.Length && !VersionData->ElementCount)
             {
-                Status = AcpiDmDumpTable (Length, Offset,
-                    ACPI_ADD_PTR (ACPI_PHAT_HEADER, Subtable, sizeof (ACPI_PHAT_VERSION_DATA)),
+                while (RecordType == 0)
+                {
+                    Subtable = ACPI_ADD_PTR (ACPI_PHAT_HEADER, Table, Offset);
+                    RecordType = *ACPI_CAST_PTR (UINT8, Subtable);
+                    RecordCount = VersionData->ElementCount;
+                    Offset += 1;
+                }
+
+                Offset -= 1;
+                AcpiOsPrintf ("\n/* Warning: Block of zeros found above starting at Offset %X Length %X */\n"
+                    "/* (not compliant to PHAT specification -- ignoring block) */\n",
+                    OriginalOffset - 12, Offset - OriginalOffset + 12);
+            }
+
+            DbgPrint (ASL_DEBUG_OUTPUT, "/* %u, RecordCount: %X, Offset %X, SubtableLength %X */\n",
+                __LINE__, RecordCount, Offset, SubtableLength);
+
+            /* Emit each of the version elements */
+
+            while (RecordCount && VersionData->Header.Length)
+            {
+                AcpiOsPrintf ("\n/* Version Element #%Xh Offset %Xh */\n\n",
+                    VersionData->ElementCount - RecordCount + 1, Offset);
+
+                Subtable = ACPI_ADD_PTR (ACPI_PHAT_HEADER, Table, Offset);
+                Status = AcpiDmDumpTable (Length, Offset, Subtable,
                     sizeof (ACPI_PHAT_VERSION_ELEMENT), AcpiDmTableInfoPhat0a);
                 if (ACPI_FAILURE (Status))
                 {
                     return;
                 }
 
+                Offset += sizeof (ACPI_PHAT_VERSION_ELEMENT);
                 RecordCount--;
             }
 
@@ -2128,28 +2056,64 @@ AcpiDmDumpPhat (
 
         case ACPI_PHAT_TYPE_FW_HEALTH_DATA:
 
-            /* account for the null terminator */
+            HealthData = ACPI_CAST_PTR (ACPI_PHAT_HEALTH_DATA, Subtable);
+            PathLength = Subtable->Length - sizeof (ACPI_PHAT_HEALTH_DATA);
+            VendorLength = 0;
 
-            PathLength = strlen (ACPI_ADD_PTR (char, Subtable, sizeof (ACPI_PHAT_HEALTH_DATA))) + 1;
-            Status = AcpiDmDumpTable (Length, Offset,
-                ACPI_ADD_PTR (ACPI_PHAT_HEADER, Subtable, sizeof (ACPI_PHAT_HEALTH_DATA)),
-                PathLength, AcpiDmTableInfoPhat1a);
-            if (ACPI_FAILURE (Status))
+            /* An offset of 0 should be ignored */
+            if (HealthData->DeviceSpecificOffset != 0)
             {
-                return;
+                if (HealthData->DeviceSpecificOffset > Subtable->Length)
+                {
+                    AcpiOsPrintf ("\n/* Warning: Oversized device-specific data offset %X */\n"
+                        "/* (maximum is %X -- ignoring device-specific data) */\n",
+                        HealthData->DeviceSpecificOffset, Subtable->Length);
+                }
+                else if (HealthData->DeviceSpecificOffset < sizeof (ACPI_PHAT_HEALTH_DATA))
+                {
+                    AcpiOsPrintf ("\n/* Warning: Undersized device-specific data offset %X */\n"
+                        "/* (minimum is %X -- ignoring device-specific data) */\n",
+                        HealthData->DeviceSpecificOffset, (UINT8) sizeof (ACPI_PHAT_HEALTH_DATA));
+                }
+                else
+                {
+                    PathLength = HealthData->DeviceSpecificOffset - sizeof (ACPI_PHAT_HEALTH_DATA);
+                    VendorLength = Subtable->Length - HealthData->DeviceSpecificOffset;
+                }
             }
 
-            /* Get vendor data - data length is the remaining subtable length */
+            DbgPrint (ASL_DEBUG_OUTPUT, "/* %u, PathLength %X, Offset %X */\n",
+                __LINE__, PathLength, Offset);
 
-            VendorLength =
-                Subtable->Length - sizeof (ACPI_PHAT_HEALTH_DATA) - PathLength;
-            Status = AcpiDmDumpTable (Length, 0,
-                ACPI_ADD_PTR (ACPI_PHAT_HEADER, Subtable, sizeof (ACPI_PHAT_HEALTH_DATA) + PathLength),
-                VendorLength, AcpiDmTableInfoPhat1b);
-            if (ACPI_FAILURE (Status))
+            if (PathLength)
             {
-                return;
+                Status = AcpiDmDumpTable (Length, Offset,
+                    ACPI_ADD_PTR (ACPI_PHAT_HEADER, Subtable, sizeof (ACPI_PHAT_HEALTH_DATA)),
+                    PathLength, AcpiDmTableInfoPhat1a);
+                if (ACPI_FAILURE (Status))
+                {
+                    return;
+                }
+
+                Offset += PathLength;
             }
+
+            DbgPrint (ASL_DEBUG_OUTPUT, "/* %u, VendorLength %X, Offset %X */\n",
+                __LINE__, VendorLength, Offset);
+
+            if (VendorLength)
+            {
+                Status = AcpiDmDumpTable (Length, Offset,
+                    ACPI_ADD_PTR (ACPI_PHAT_HEADER, Subtable, HealthData->DeviceSpecificOffset),
+                    VendorLength, AcpiDmTableInfoPhat1b);
+                if (ACPI_FAILURE (Status))
+                {
+                    return;
+                }
+
+                Offset += VendorLength;
+            }
+
             break;
 
         default:
@@ -2161,9 +2125,12 @@ AcpiDmDumpPhat (
 
         /* Next subtable */
 
-        Offset += Subtable->Length;
-        Subtable = ACPI_ADD_PTR (ACPI_PHAT_HEADER, Subtable,
-            Subtable->Length);
+        DbgPrint (ASL_DEBUG_OUTPUT, "/* %u, Bottom of main loop: Offset %X, "
+            "Subtable->Length %X, Table->Length %X */\n",
+            __LINE__, Offset, Subtable->Length, Table->Length);
+
+        Subtable = ACPI_ADD_PTR (ACPI_PHAT_HEADER, Table,
+            Offset);
     }
 }
 
@@ -2474,6 +2441,60 @@ AcpiDmDumpPrmt (
 }
 
 
+/*******************************************************************************
+ *
+ * FUNCTION:    AcpiDmDumpRas2
+ *
+ * PARAMETERS:  Table               - A RAS2 table
+ *
+ * RETURN:      None
+ *
+ * DESCRIPTION: Format the contents of a Ras2. This is a variable-length
+ *              table that contains an open-ended number of the RAS2 PCC
+ *              descriptors at the end of the table.
+ *
+ ******************************************************************************/
+
+void
+AcpiDmDumpRas2 (
+    ACPI_TABLE_HEADER       *Table)
+{
+    ACPI_STATUS             Status;
+    ACPI_RAS2_PCC_DESC      *Subtable;
+    UINT32                  Length = Table->Length;
+    UINT32                  Offset = sizeof (ACPI_TABLE_RAS2);
+
+
+    /* Main table */
+
+    Status = AcpiDmDumpTable (Length, 0, Table, 0, AcpiDmTableInfoRas2);
+    if (ACPI_FAILURE (Status))
+    {
+        return;
+    }
+
+    /* Subtables - RAS2 PCC descriptor list */
+
+    Subtable = ACPI_ADD_PTR (ACPI_RAS2_PCC_DESC, Table, Offset);
+    while (Offset < Table->Length)
+    {
+        AcpiOsPrintf ("\n");
+        Status = AcpiDmDumpTable (Length, Offset, Subtable,
+            sizeof (ACPI_RAS2_PCC_DESC), AcpiDmTableInfoRas2PccDesc);
+        if (ACPI_FAILURE (Status))
+        {
+            return;
+        }
+
+        /* Point to next subtable */
+
+        Offset += sizeof (ACPI_RAS2_PCC_DESC);
+        Subtable = ACPI_ADD_PTR (ACPI_RAS2_PCC_DESC, Subtable,
+            sizeof (ACPI_RAS2_PCC_DESC));
+    }
+}
+
+
 /*******************************************************************************
  *
  * FUNCTION:    AcpiDmDumpRgrt
